#ifndef __PYX_HAVE__petsc4py__PETSc
#define __PYX_HAVE__petsc4py__PETSc
#ifdef __cplusplus
#define __PYX_EXTERN_C extern "C"
#else
#define __PYX_EXTERN_C extern
#endif

/* "include/petsc4py/PETSc.pxd":63
 * # --------------------------------------------------------------------
 * 
 * ctypedef public api class Comm [type PyPetscComm_Type, object PyPetscCommObject]:             # <<<<<<<<<<<<<<
 *     cdef MPI_Comm comm
 *     cdef int isdup
 */

typedef struct {
  PyObject_HEAD
  MPI_Comm comm;
  int isdup;
  PyObject *base;
} PyPetscCommObject;

/* "include/petsc4py/PETSc.pxd":68
 *     cdef object base
 * 
 * ctypedef public api class Object [type PyPetscObject_Type, object PyPetscObjectObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscObject oval
 *     cdef PetscObject *obj
 */

typedef struct {
  PyObject_HEAD
  struct __pyx_vtabstruct_8petsc4py_5PETSc_Object *__pyx_vtab;
  PetscObject oval;
  PetscObject *obj;
} PyPetscObjectObject;

/* "include/petsc4py/PETSc.pxd":77
 *     cdef object get_dict(self)
 * 
 * ctypedef public api class Viewer(Object) [type PyPetscViewer_Type, object PyPetscViewerObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscViewer vwr
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  PetscViewer vwr;
} PyPetscViewerObject;

/* "include/petsc4py/PETSc.pxd":80
 *     cdef PetscViewer vwr
 * 
 * ctypedef public api class Random(Object) [type PyPetscRandom_Type, object PyPetscRandomObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscRandom rnd
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  PetscRandom rnd;
} PyPetscRandomObject;

/* "include/petsc4py/PETSc.pxd":83
 *     cdef PetscRandom rnd
 * 
 * ctypedef public api class IS(Object) [type PyPetscIS_Type, object PyPetscISObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscIS iset
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  IS iset;
} PyPetscISObject;

/* "include/petsc4py/PETSc.pxd":86
 *     cdef PetscIS iset
 * 
 * ctypedef public api class LGMap(Object) [type PyPetscLGMap_Type, object PyPetscLGMapObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscLGMap lgm
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  ISLocalToGlobalMapping lgm;
} PyPetscLGMapObject;

/* "include/petsc4py/PETSc.pxd":89
 *     cdef PetscLGMap lgm
 * 
 * ctypedef public api class Vec(Object) [type PyPetscVec_Type, object PyPetscVecObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscVec vec
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  Vec vec;
} PyPetscVecObject;

/* "include/petsc4py/PETSc.pxd":92
 *     cdef PetscVec vec
 * 
 * ctypedef public api class Scatter(Object) [type PyPetscScatter_Type, object PyPetscScatterObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscScatter sct
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  VecScatter sct;
} PyPetscScatterObject;

/* "include/petsc4py/PETSc.pxd":95
 *     cdef PetscScatter sct
 * 
 * ctypedef public api class Mat(Object) [type PyPetscMat_Type, object PyPetscMatObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscMat mat
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  Mat mat;
} PyPetscMatObject;

/* "include/petsc4py/PETSc.pxd":98
 *     cdef PetscMat mat
 * 
 * ctypedef public api class NullSpace(Object) [type PyPetscNullSpace_Type, object PyPetscNullSpaceObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscNullSpace nsp
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  MatNullSpace nsp;
} PyPetscNullSpaceObject;

/* "include/petsc4py/PETSc.pxd":101
 *     cdef PetscNullSpace nsp
 * 
 * ctypedef public api class PC(Object) [type PyPetscPC_Type, object PyPetscPCObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscPC pc
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  PC pc;
} PyPetscPCObject;

/* "include/petsc4py/PETSc.pxd":104
 *     cdef PetscPC pc
 * 
 * ctypedef public api class KSP(Object) [type PyPetscKSP_Type, object PyPetscKSPObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscKSP ksp
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  KSP ksp;
} PyPetscKSPObject;

/* "include/petsc4py/PETSc.pxd":107
 *     cdef PetscKSP ksp
 * 
 * ctypedef public api class SNES(Object) [type PyPetscSNES_Type, object PyPetscSNESObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscSNES snes
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  SNES snes;
} PyPetscSNESObject;

/* "include/petsc4py/PETSc.pxd":110
 *     cdef PetscSNES snes
 * 
 * ctypedef public api class TS(Object) [type PyPetscTS_Type, object PyPetscTSObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscTS ts
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  TS ts;
} PyPetscTSObject;

/* "include/petsc4py/PETSc.pxd":113
 *     cdef PetscTS ts
 * 
 * ctypedef public api class AO(Object) [type PyPetscAO_Type, object PyPetscAOObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscAO ao
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  AO ao;
} PyPetscAOObject;

/* "include/petsc4py/PETSc.pxd":116
 *     cdef PetscAO ao
 * 
 * ctypedef public api class DA(Object) [type PyPetscDA_Type, object PyPetscDAObject]:             # <<<<<<<<<<<<<<
 *     cdef PetscDA da
 * 
 */

typedef struct {
  PyPetscObjectObject __pyx_base;
  DA da;
} PyPetscDAObject;

#ifndef __PYX_HAVE_API__petsc4py__PETSc

__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscComm_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscObject_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscViewer_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscRandom_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscIS_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscLGMap_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscVec_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscScatter_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscMat_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscNullSpace_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscPC_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscKSP_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscSNES_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscTS_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscAO_Type;
__PYX_EXTERN_C DL_IMPORT(PyTypeObject) PyPetscDA_Type;

#endif

PyMODINIT_FUNC initPETSc(void);

#endif
